SystemOrganization addCategory: #CreditCard!

Magnitude subclass: #MonthOfYear
	instanceVariableNames: 'monthNumber yearNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CreditCard'!

!MonthOfYear class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 10:32'!
januaryOf: aYearNumber

	^ self onMonthNumber: 1 of: aYearNumber  
	
	! !

!MonthOfYear class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 10:32'!
onMonthNumber: aMonthNumber of: aYearNumber

	^ self new initializeOnMonthNumber: aMonthNumber of: aYearNumber! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:56'!
< aMonthOfYear

	^ yearNumber < aMonthOfYear yearNumber  or: [ yearNumber = aMonthOfYear yearNumber and: monthNumber < aMonthOfYear monthNumber ]! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:40'!
= anObject

	^ (anObject isKindOf: self class) and: [ monthNumber = anObject monthNumber and: [ yearNumber = anObject yearNumber ]]! !

!MonthOfYear methodsFor: 'comparing' stamp: 'HernanWilkinson 6/7/2012 11:44'!
hash

	^ monthNumber hash bitXor: yearNumber hash! !

!MonthOfYear methodsFor: 'initialization' stamp: 'HernanWilkinson 6/7/2012 11:42'!
initializeOnMonthNumber: aMonthNumber of: aYearNumber

	monthNumber := aMonthNumber.
	yearNumber := aYearNumber! !

!MonthOfYear methodsFor: 'month' stamp: 'HernanWilkinson 6/7/2012 11:40'!
monthNumber
	
	^ monthNumber! !

!MonthOfYear methodsFor: 'year' stamp: 'HernanWilkinson 6/7/2012 11:41'!
yearNumber
	
	^ yearNumber! !

Object subclass: #CreditCard
	instanceVariableNames: 'ownerName number expirationDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CreditCard'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:49'!
invalidOwnerNameErrorDescription
	
	^ 'Owner name can not be empty'! !

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:47'!
ownedBy: anOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
	
	| trimmedOwnerName | 
	
	trimmedOwnerName := anOwnerName trimBoth.
	self validateOwnerName: trimmedOwnerName.
	
	^ self new initializeOwnedBy: trimmedOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
! !

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'HernanWilkinson 6/7/2012 11:48'!
validateOwnerName: trimmedOwnerName

	trimmedOwnerName isEmpty ifTrue: [ self error: self invalidOwnerNameErrorDescription ]! !

!CreditCard methodsFor: 'expiration' stamp: 'HernanWilkinson 6/7/2012 11:37'!
expirationDate

	^ expirationDate! !

!CreditCard methodsFor: 'initialization' stamp: 'HernanWilkinson 6/7/2012 11:36'!
initializeOwnedBy: anOwnerName identifiedBy: aNumber expiresOn: anExpirationDate 
	
	ownerName := anOwnerName.
	number := aNumber.
	expirationDate := anExpirationDate! !

!CreditCard methodsFor: 'expiration' stamp: 'HernanWilkinson 6/7/2012 12:02'!
isExpiredOn: aMonthOfYear 
	
	^ aMonthOfYear > expirationDate ! !

!CreditCard methodsFor: 'number' stamp: 'HernanWilkinson 6/7/2012 11:34'!
number
	^ number! !

!CreditCard methodsFor: 'owner' stamp: 'HernanWilkinson 6/7/2012 11:34'!
ownerName
	^ ownerName! !

TestCase subclass: #CreditCardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CreditCard'!

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:32'!
test01CanCreateACreditCardWithValidOwnerNameNumberAndExpirationDate

	self 
		shouldnt: [ CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error 
		! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:33'!
test02CreditCardRemembersTheOwnerName

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) ownerName = self validOwnerName ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:34'!
test03CreditCardRemembersTheNumber

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) number = self validNumber! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:44'!
test04CreditCardRemembersTheExpirationDate

	self assert: (CreditCard ownedBy: self validOwnerName identifiedBy: self validNumber expiresOn: self validExpirationDate) expirationDate = self validExpirationDate ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:51'!
test05CanNotCreateACreditCardWithEmptyOwnerName

	self 
		should: [ CreditCard ownedBy:'' identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText  = CreditCard invalidOwnerNameErrorDescription ]! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:51'!
test06CanNotCreateACreditCardWithBlanksOwnerName

	self 
		should: [ CreditCard ownedBy:'  ' identifiedBy: self validNumber expiresOn: self validExpirationDate ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText  = CreditCard invalidOwnerNameErrorDescription ]! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:53'!
test07OwnerNameGetsTrimmed

	self assert: (CreditCard ownedBy: ' pepe ' identifiedBy:  self validNumber expiresOn: self validExpirationDate ) ownerName = 'pepe'! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:03'!
test08ACreditCardIsExpiredIfTheCurrentMonthOfYearIsBiggerThanExpirationDate

	| expirationDate currentMonthOfYear |
	
	expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.
	currentMonthOfYear := MonthOfYear onMonthNumber: 2 of:  2012. 
	self assert: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: expirationDate ) isExpiredOn: currentMonthOfYear) ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:03'!
test09ACreditCardIsNotExpiredIfTheCurrentMonthOfYearIsEqualToExpirationDate

	self deny: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: self validExpirationDate ) isExpiredOn: self validExpirationDate ) ! !

!CreditCardTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 12:04'!
test10ACreditCardIsNotExpiredIfTheCurrentMonthOfYearIsLessThanExpirationDate

	| expirationDate currentMonthOfYear |
	
	expirationDate := MonthOfYear onMonthNumber: 1 of: 2012.
	currentMonthOfYear := MonthOfYear onMonthNumber: 12 of:  2011. 
	self deny: ((CreditCard ownedBy: self validOwnerName identifiedBy:  self validNumber expiresOn: expirationDate ) isExpiredOn: currentMonthOfYear) ! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:31'!
validExpirationDate
	
	^ MonthOfYear januaryOf: 2012! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:30'!
validNumber
	
	 ^ '0123456789012345'! !

!CreditCardTest methodsFor: 'test objects' stamp: 'HernanWilkinson 6/7/2012 10:30'!
validOwnerName

	^ 'Pepe Sanchez'! !

TestCase subclass: #MonthOfYearTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CreditCard'!

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:39'!
test01DifferentObjectsAreEqualIfTheyRepresentTheSameMonthOfYear

	self assert: (MonthOfYear onMonthNumber: 1 of: 2012) = (MonthOfYear onMonthNumber: 1 of: 2012)! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:42'!
test02DifferentObjectsAreNotEqualfTheyDoNotRepresentTheSameMonthOfYear

	self deny: (MonthOfYear onMonthNumber: 2 of: 2012) = (MonthOfYear onMonthNumber: 1 of: 2012)! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:43'!
test03DifferentObjectsThatAreEqualHaveTheSameHash

	self assert: (MonthOfYear onMonthNumber: 1 of: 2012) hash = (MonthOfYear onMonthNumber: 1 of: 2012) hash! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:54'!
test04AMonthOfYearIsLessThanOtherIfTheYearIsLess

	self assert: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2012) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:57'!
test05AMonthOfYearIsLessThanOtherIfTheYearIsEqualButTheMonthIsLess

	self assert: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 2 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:58'!
test06AMonthOfYearIsNotLessThanOtherIfTheyAreEqual

	self deny: (MonthOfYear onMonthNumber: 1 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:58'!
test07AMonthOfYearIsNotLessThanOtherIfTheYearIsBigger

	self deny: (MonthOfYear onMonthNumber: 1 of: 2012) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !

!MonthOfYearTest methodsFor: 'test' stamp: 'HernanWilkinson 6/7/2012 11:59'!
test08AMonthOfYearIsNotLessThanOtherIfTheYearIsEqualButTheMonthIsBigger

	self deny: (MonthOfYear onMonthNumber: 2 of: 2011) < (MonthOfYear onMonthNumber: 1 of: 2011) ! !
